"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isEventDefined = exports.isEvent = exports.isErrorEvent = exports.isErrorDefined = exports.isError = exports.isElementDefined = exports.isElement = exports.isDomException = exports.isDomError = exports.isBoolean = exports.isArray = exports.internalGlobalObjectKey = exports.globalObject = exports.getTransportBody = exports.getInternalFaroFromGlobalObject = exports.getCurrentTimestamp = exports.genShortID = exports.defaultLogLevel = exports.defaultInternalLoggerLevel = exports.defaultGlobalObjectKey = exports.defaultExceptionType = exports.deepEqual = exports.createPromiseBuffer = exports.createInternalLogger = exports.Conventions = exports.BaseTransport = exports.BaseInstrumentation = exports.BaseExtension = exports.allLogLevels = exports.faro = exports.FetchTransport = exports.ConsoleTransport = exports.sdkMeta = exports.createSession = exports.browserMeta = exports.UserActionInstrumentation = exports.PerformanceInstrumentation = exports.SessionInstrumentation = exports.WebVitalsInstrumentation = exports.ViewInstrumentation = exports.parseStacktrace = exports.getStackFramesFromError = exports.getDataFromSafariExtensions = exports.ErrorsInstrumentation = exports.ConsoleInstrumentation = exports.buildStackFrame = exports.initializeFaro = exports.defaultEventDomain = exports.makeCoreConfig = exports.getWebInstrumentations = void 0;
exports.userActionDataAttribute = exports.getUrlFromResource = exports.getIgnoreUrls = exports.STORAGE_KEY = exports.SESSION_INACTIVITY_TIME = exports.SESSION_EXPIRATION_TIME = exports.MAX_SESSION_PERSISTENCE_TIME_BUFFER = exports.MAX_SESSION_PERSISTENCE_TIME = exports.VolatileSessionsManager = exports.PersistentSessionsManager = exports.unknownString = exports.USER_ACTION_START = exports.USER_ACTION_HALT = exports.USER_ACTION_END = exports.USER_ACTION_CANCEL = exports.Observable = exports.apiMessageBus = exports.EVENT_VIEW_CHANGED = exports.EVENT_SESSION_START = exports.EVENT_SESSION_RESUME = exports.EVENT_SESSION_EXTEND = exports.EVENT_ROUTE_CHANGE = exports.EVENT_NAVIGATION = exports.EVENT_CLICK = exports.VERSION = exports.transportItemTypeToBodyKey = exports.TransportItemType = exports.setInternalFaroOnGlobalObject = exports.noop = exports.LogLevel = exports.InternalLoggerLevel = exports.isEmpty = exports.isUndefined = exports.isTypeof = exports.isToString = exports.isThenable = exports.isSyntheticEvent = exports.isSymbol = exports.isString = exports.isRegExp = exports.isPrimitive = exports.isObject = exports.isNumber = exports.isNull = exports.isMapDefined = exports.isMap = exports.isInternalFaroOnGlobalObject = exports.isInt = exports.isInstanceOf = exports.isFunction = void 0;
exports.startUserAction = void 0;
var config_1 = require("./config");
Object.defineProperty(exports, "getWebInstrumentations", { enumerable: true, get: function () { return config_1.getWebInstrumentations; } });
Object.defineProperty(exports, "makeCoreConfig", { enumerable: true, get: function () { return config_1.makeCoreConfig; } });
var consts_1 = require("./consts");
Object.defineProperty(exports, "defaultEventDomain", { enumerable: true, get: function () { return consts_1.defaultEventDomain; } });
var initialize_1 = require("./initialize");
Object.defineProperty(exports, "initializeFaro", { enumerable: true, get: function () { return initialize_1.initializeFaro; } });
var instrumentations_1 = require("./instrumentations");
Object.defineProperty(exports, "buildStackFrame", { enumerable: true, get: function () { return instrumentations_1.buildStackFrame; } });
Object.defineProperty(exports, "ConsoleInstrumentation", { enumerable: true, get: function () { return instrumentations_1.ConsoleInstrumentation; } });
Object.defineProperty(exports, "ErrorsInstrumentation", { enumerable: true, get: function () { return instrumentations_1.ErrorsInstrumentation; } });
Object.defineProperty(exports, "getDataFromSafariExtensions", { enumerable: true, get: function () { return instrumentations_1.getDataFromSafariExtensions; } });
Object.defineProperty(exports, "getStackFramesFromError", { enumerable: true, get: function () { return instrumentations_1.getStackFramesFromError; } });
Object.defineProperty(exports, "parseStacktrace", { enumerable: true, get: function () { return instrumentations_1.parseStacktrace; } });
Object.defineProperty(exports, "ViewInstrumentation", { enumerable: true, get: function () { return instrumentations_1.ViewInstrumentation; } });
Object.defineProperty(exports, "WebVitalsInstrumentation", { enumerable: true, get: function () { return instrumentations_1.WebVitalsInstrumentation; } });
Object.defineProperty(exports, "SessionInstrumentation", { enumerable: true, get: function () { return instrumentations_1.SessionInstrumentation; } });
Object.defineProperty(exports, "PerformanceInstrumentation", { enumerable: true, get: function () { return instrumentations_1.PerformanceInstrumentation; } });
Object.defineProperty(exports, "UserActionInstrumentation", { enumerable: true, get: function () { return instrumentations_1.UserActionInstrumentation; } });
var metas_1 = require("./metas");
Object.defineProperty(exports, "browserMeta", { enumerable: true, get: function () { return metas_1.browserMeta; } });
Object.defineProperty(exports, "createSession", { enumerable: true, get: function () { return metas_1.createSession; } });
Object.defineProperty(exports, "sdkMeta", { enumerable: true, get: function () { return metas_1.sdkMeta; } });
var transports_1 = require("./transports");
Object.defineProperty(exports, "ConsoleTransport", { enumerable: true, get: function () { return transports_1.ConsoleTransport; } });
Object.defineProperty(exports, "FetchTransport", { enumerable: true, get: function () { return transports_1.FetchTransport; } });
var faro_core_1 = require("@grafana/faro-core");
Object.defineProperty(exports, "faro", { enumerable: true, get: function () { return faro_core_1.faro; } });
Object.defineProperty(exports, "allLogLevels", { enumerable: true, get: function () { return faro_core_1.allLogLevels; } });
Object.defineProperty(exports, "BaseExtension", { enumerable: true, get: function () { return faro_core_1.BaseExtension; } });
Object.defineProperty(exports, "BaseInstrumentation", { enumerable: true, get: function () { return faro_core_1.BaseInstrumentation; } });
Object.defineProperty(exports, "BaseTransport", { enumerable: true, get: function () { return faro_core_1.BaseTransport; } });
Object.defineProperty(exports, "Conventions", { enumerable: true, get: function () { return faro_core_1.Conventions; } });
Object.defineProperty(exports, "createInternalLogger", { enumerable: true, get: function () { return faro_core_1.createInternalLogger; } });
Object.defineProperty(exports, "createPromiseBuffer", { enumerable: true, get: function () { return faro_core_1.createPromiseBuffer; } });
Object.defineProperty(exports, "deepEqual", { enumerable: true, get: function () { return faro_core_1.deepEqual; } });
Object.defineProperty(exports, "defaultExceptionType", { enumerable: true, get: function () { return faro_core_1.defaultExceptionType; } });
Object.defineProperty(exports, "defaultGlobalObjectKey", { enumerable: true, get: function () { return faro_core_1.defaultGlobalObjectKey; } });
Object.defineProperty(exports, "defaultInternalLoggerLevel", { enumerable: true, get: function () { return faro_core_1.defaultInternalLoggerLevel; } });
Object.defineProperty(exports, "defaultLogLevel", { enumerable: true, get: function () { return faro_core_1.defaultLogLevel; } });
Object.defineProperty(exports, "genShortID", { enumerable: true, get: function () { return faro_core_1.genShortID; } });
Object.defineProperty(exports, "getCurrentTimestamp", { enumerable: true, get: function () { return faro_core_1.getCurrentTimestamp; } });
Object.defineProperty(exports, "getInternalFaroFromGlobalObject", { enumerable: true, get: function () { return faro_core_1.getInternalFaroFromGlobalObject; } });
Object.defineProperty(exports, "getTransportBody", { enumerable: true, get: function () { return faro_core_1.getTransportBody; } });
Object.defineProperty(exports, "globalObject", { enumerable: true, get: function () { return faro_core_1.globalObject; } });
Object.defineProperty(exports, "internalGlobalObjectKey", { enumerable: true, get: function () { return faro_core_1.internalGlobalObjectKey; } });
Object.defineProperty(exports, "isArray", { enumerable: true, get: function () { return faro_core_1.isArray; } });
Object.defineProperty(exports, "isBoolean", { enumerable: true, get: function () { return faro_core_1.isBoolean; } });
Object.defineProperty(exports, "isDomError", { enumerable: true, get: function () { return faro_core_1.isDomError; } });
Object.defineProperty(exports, "isDomException", { enumerable: true, get: function () { return faro_core_1.isDomException; } });
Object.defineProperty(exports, "isElement", { enumerable: true, get: function () { return faro_core_1.isElement; } });
Object.defineProperty(exports, "isElementDefined", { enumerable: true, get: function () { return faro_core_1.isElementDefined; } });
Object.defineProperty(exports, "isError", { enumerable: true, get: function () { return faro_core_1.isError; } });
Object.defineProperty(exports, "isErrorDefined", { enumerable: true, get: function () { return faro_core_1.isErrorDefined; } });
Object.defineProperty(exports, "isErrorEvent", { enumerable: true, get: function () { return faro_core_1.isErrorEvent; } });
Object.defineProperty(exports, "isEvent", { enumerable: true, get: function () { return faro_core_1.isEvent; } });
Object.defineProperty(exports, "isEventDefined", { enumerable: true, get: function () { return faro_core_1.isEventDefined; } });
Object.defineProperty(exports, "isFunction", { enumerable: true, get: function () { return faro_core_1.isFunction; } });
Object.defineProperty(exports, "isInstanceOf", { enumerable: true, get: function () { return faro_core_1.isInstanceOf; } });
Object.defineProperty(exports, "isInt", { enumerable: true, get: function () { return faro_core_1.isInt; } });
Object.defineProperty(exports, "isInternalFaroOnGlobalObject", { enumerable: true, get: function () { return faro_core_1.isInternalFaroOnGlobalObject; } });
Object.defineProperty(exports, "isMap", { enumerable: true, get: function () { return faro_core_1.isMap; } });
Object.defineProperty(exports, "isMapDefined", { enumerable: true, get: function () { return faro_core_1.isMapDefined; } });
Object.defineProperty(exports, "isNull", { enumerable: true, get: function () { return faro_core_1.isNull; } });
Object.defineProperty(exports, "isNumber", { enumerable: true, get: function () { return faro_core_1.isNumber; } });
Object.defineProperty(exports, "isObject", { enumerable: true, get: function () { return faro_core_1.isObject; } });
Object.defineProperty(exports, "isPrimitive", { enumerable: true, get: function () { return faro_core_1.isPrimitive; } });
Object.defineProperty(exports, "isRegExp", { enumerable: true, get: function () { return faro_core_1.isRegExp; } });
Object.defineProperty(exports, "isString", { enumerable: true, get: function () { return faro_core_1.isString; } });
Object.defineProperty(exports, "isSymbol", { enumerable: true, get: function () { return faro_core_1.isSymbol; } });
Object.defineProperty(exports, "isSyntheticEvent", { enumerable: true, get: function () { return faro_core_1.isSyntheticEvent; } });
Object.defineProperty(exports, "isThenable", { enumerable: true, get: function () { return faro_core_1.isThenable; } });
Object.defineProperty(exports, "isToString", { enumerable: true, get: function () { return faro_core_1.isToString; } });
Object.defineProperty(exports, "isTypeof", { enumerable: true, get: function () { return faro_core_1.isTypeof; } });
Object.defineProperty(exports, "isUndefined", { enumerable: true, get: function () { return faro_core_1.isUndefined; } });
Object.defineProperty(exports, "isEmpty", { enumerable: true, get: function () { return faro_core_1.isEmpty; } });
Object.defineProperty(exports, "InternalLoggerLevel", { enumerable: true, get: function () { return faro_core_1.InternalLoggerLevel; } });
Object.defineProperty(exports, "LogLevel", { enumerable: true, get: function () { return faro_core_1.LogLevel; } });
Object.defineProperty(exports, "noop", { enumerable: true, get: function () { return faro_core_1.noop; } });
Object.defineProperty(exports, "setInternalFaroOnGlobalObject", { enumerable: true, get: function () { return faro_core_1.setInternalFaroOnGlobalObject; } });
Object.defineProperty(exports, "TransportItemType", { enumerable: true, get: function () { return faro_core_1.TransportItemType; } });
Object.defineProperty(exports, "transportItemTypeToBodyKey", { enumerable: true, get: function () { return faro_core_1.transportItemTypeToBodyKey; } });
Object.defineProperty(exports, "VERSION", { enumerable: true, get: function () { return faro_core_1.VERSION; } });
Object.defineProperty(exports, "EVENT_CLICK", { enumerable: true, get: function () { return faro_core_1.EVENT_CLICK; } });
Object.defineProperty(exports, "EVENT_NAVIGATION", { enumerable: true, get: function () { return faro_core_1.EVENT_NAVIGATION; } });
Object.defineProperty(exports, "EVENT_ROUTE_CHANGE", { enumerable: true, get: function () { return faro_core_1.EVENT_ROUTE_CHANGE; } });
Object.defineProperty(exports, "EVENT_SESSION_EXTEND", { enumerable: true, get: function () { return faro_core_1.EVENT_SESSION_EXTEND; } });
Object.defineProperty(exports, "EVENT_SESSION_RESUME", { enumerable: true, get: function () { return faro_core_1.EVENT_SESSION_RESUME; } });
Object.defineProperty(exports, "EVENT_SESSION_START", { enumerable: true, get: function () { return faro_core_1.EVENT_SESSION_START; } });
Object.defineProperty(exports, "EVENT_VIEW_CHANGED", { enumerable: true, get: function () { return faro_core_1.EVENT_VIEW_CHANGED; } });
Object.defineProperty(exports, "apiMessageBus", { enumerable: true, get: function () { return faro_core_1.apiMessageBus; } });
Object.defineProperty(exports, "Observable", { enumerable: true, get: function () { return faro_core_1.Observable; } });
Object.defineProperty(exports, "USER_ACTION_CANCEL", { enumerable: true, get: function () { return faro_core_1.USER_ACTION_CANCEL; } });
Object.defineProperty(exports, "USER_ACTION_END", { enumerable: true, get: function () { return faro_core_1.USER_ACTION_END; } });
Object.defineProperty(exports, "USER_ACTION_HALT", { enumerable: true, get: function () { return faro_core_1.USER_ACTION_HALT; } });
Object.defineProperty(exports, "USER_ACTION_START", { enumerable: true, get: function () { return faro_core_1.USER_ACTION_START; } });
Object.defineProperty(exports, "unknownString", { enumerable: true, get: function () { return faro_core_1.unknownString; } });
var session_1 = require("./instrumentations/session");
Object.defineProperty(exports, "PersistentSessionsManager", { enumerable: true, get: function () { return session_1.PersistentSessionsManager; } });
Object.defineProperty(exports, "VolatileSessionsManager", { enumerable: true, get: function () { return session_1.VolatileSessionsManager; } });
Object.defineProperty(exports, "MAX_SESSION_PERSISTENCE_TIME", { enumerable: true, get: function () { return session_1.MAX_SESSION_PERSISTENCE_TIME; } });
Object.defineProperty(exports, "MAX_SESSION_PERSISTENCE_TIME_BUFFER", { enumerable: true, get: function () { return session_1.MAX_SESSION_PERSISTENCE_TIME_BUFFER; } });
Object.defineProperty(exports, "SESSION_EXPIRATION_TIME", { enumerable: true, get: function () { return session_1.SESSION_EXPIRATION_TIME; } });
Object.defineProperty(exports, "SESSION_INACTIVITY_TIME", { enumerable: true, get: function () { return session_1.SESSION_INACTIVITY_TIME; } });
Object.defineProperty(exports, "STORAGE_KEY", { enumerable: true, get: function () { return session_1.STORAGE_KEY; } });
var url_1 = require("./utils/url");
Object.defineProperty(exports, "getIgnoreUrls", { enumerable: true, get: function () { return url_1.getIgnoreUrls; } });
Object.defineProperty(exports, "getUrlFromResource", { enumerable: true, get: function () { return url_1.getUrlFromResource; } });
var userActions_1 = require("./instrumentations/userActions");
Object.defineProperty(exports, "userActionDataAttribute", { enumerable: true, get: function () { return userActions_1.userActionDataAttribute; } });
Object.defineProperty(exports, "startUserAction", { enumerable: true, get: function () { return userActions_1.startUserAction; } });
//# sourceMappingURL=index.js.map